package com.hfkj.dao;

import com.hfkj.entity.BsDiscountStockCode;
import com.hfkj.entity.BsDiscountStockCodeExample.Criteria;
import com.hfkj.entity.BsDiscountStockCodeExample.Criterion;
import com.hfkj.entity.BsDiscountStockCodeExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsDiscountStockCodeSqlProvider {

    public String countByExample(BsDiscountStockCodeExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_discount_stock_code");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsDiscountStockCodeExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_discount_stock_code");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsDiscountStockCode record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_discount_stock_code");
        
        if (record.getDiscountStockBatchId() != null) {
            sql.VALUES("discount_stock_batch_id", "#{discountStockBatchId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountStockBatchNo() != null) {
            sql.VALUES("discount_stock_batch_no", "#{discountStockBatchNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountId() != null) {
            sql.VALUES("discount_id", "#{discountId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountNo() != null) {
            sql.VALUES("discount_no", "#{discountNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountName() != null) {
            sql.VALUES("discount_name", "#{discountName,jdbcType=VARCHAR}");
        }
        
        if (record.getObtainType() != null) {
            sql.VALUES("obtain_type", "#{obtainType,jdbcType=INTEGER}");
        }
        
        if (record.getObtainTime() != null) {
            sql.VALUES("obtain_time", "#{obtainTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getReceiveMerUserId() != null) {
            sql.VALUES("receive_mer_user_id", "#{receiveMerUserId,jdbcType=BIGINT}");
        }
        
        if (record.getReceiveMerUserPhone() != null) {
            sql.VALUES("receive_mer_user_phone", "#{receiveMerUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getUseTime() != null) {
            sql.VALUES("use_time", "#{useTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountPkStockCode() != null) {
            sql.VALUES("discount_pk_stock_code", "#{discountPkStockCode,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountPkId() != null) {
            sql.VALUES("discount_pk_id", "#{discountPkId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountPkNo() != null) {
            sql.VALUES("discount_pk_no", "#{discountPkNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPkName() != null) {
            sql.VALUES("discount_pk_name", "#{discountPkName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentAppid() != null) {
            sql.VALUES("agent_appid", "#{agentAppid,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsDiscountStockCodeExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("discount_stock_batch_id");
        sql.SELECT("discount_stock_batch_no");
        sql.SELECT("discount_id");
        sql.SELECT("discount_no");
        sql.SELECT("discount_name");
        sql.SELECT("obtain_type");
        sql.SELECT("obtain_time");
        sql.SELECT("receive_mer_user_id");
        sql.SELECT("receive_mer_user_phone");
        sql.SELECT("use_time");
        sql.SELECT("`status`");
        sql.SELECT("discount_pk_stock_code");
        sql.SELECT("discount_pk_id");
        sql.SELECT("discount_pk_no");
        sql.SELECT("discount_pk_name");
        sql.SELECT("agent_appid");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_discount_stock_code");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsDiscountStockCode record = (BsDiscountStockCode) parameter.get("record");
        BsDiscountStockCodeExample example = (BsDiscountStockCodeExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_discount_stock_code");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountStockBatchId() != null) {
            sql.SET("discount_stock_batch_id = #{record.discountStockBatchId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountStockBatchNo() != null) {
            sql.SET("discount_stock_batch_no = #{record.discountStockBatchNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountId() != null) {
            sql.SET("discount_id = #{record.discountId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountNo() != null) {
            sql.SET("discount_no = #{record.discountNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountName() != null) {
            sql.SET("discount_name = #{record.discountName,jdbcType=VARCHAR}");
        }
        
        if (record.getObtainType() != null) {
            sql.SET("obtain_type = #{record.obtainType,jdbcType=INTEGER}");
        }
        
        if (record.getObtainTime() != null) {
            sql.SET("obtain_time = #{record.obtainTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getReceiveMerUserId() != null) {
            sql.SET("receive_mer_user_id = #{record.receiveMerUserId,jdbcType=BIGINT}");
        }
        
        if (record.getReceiveMerUserPhone() != null) {
            sql.SET("receive_mer_user_phone = #{record.receiveMerUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getUseTime() != null) {
            sql.SET("use_time = #{record.useTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountPkStockCode() != null) {
            sql.SET("discount_pk_stock_code = #{record.discountPkStockCode,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountPkId() != null) {
            sql.SET("discount_pk_id = #{record.discountPkId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountPkNo() != null) {
            sql.SET("discount_pk_no = #{record.discountPkNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPkName() != null) {
            sql.SET("discount_pk_name = #{record.discountPkName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentAppid() != null) {
            sql.SET("agent_appid = #{record.agentAppid,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_discount_stock_code");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("discount_stock_batch_id = #{record.discountStockBatchId,jdbcType=BIGINT}");
        sql.SET("discount_stock_batch_no = #{record.discountStockBatchNo,jdbcType=VARCHAR}");
        sql.SET("discount_id = #{record.discountId,jdbcType=BIGINT}");
        sql.SET("discount_no = #{record.discountNo,jdbcType=VARCHAR}");
        sql.SET("discount_name = #{record.discountName,jdbcType=VARCHAR}");
        sql.SET("obtain_type = #{record.obtainType,jdbcType=INTEGER}");
        sql.SET("obtain_time = #{record.obtainTime,jdbcType=TIMESTAMP}");
        sql.SET("receive_mer_user_id = #{record.receiveMerUserId,jdbcType=BIGINT}");
        sql.SET("receive_mer_user_phone = #{record.receiveMerUserPhone,jdbcType=VARCHAR}");
        sql.SET("use_time = #{record.useTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("discount_pk_stock_code = #{record.discountPkStockCode,jdbcType=BIGINT}");
        sql.SET("discount_pk_id = #{record.discountPkId,jdbcType=BIGINT}");
        sql.SET("discount_pk_no = #{record.discountPkNo,jdbcType=VARCHAR}");
        sql.SET("discount_pk_name = #{record.discountPkName,jdbcType=VARCHAR}");
        sql.SET("agent_appid = #{record.agentAppid,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsDiscountStockCodeExample example = (BsDiscountStockCodeExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsDiscountStockCode record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_discount_stock_code");
        
        if (record.getDiscountStockBatchId() != null) {
            sql.SET("discount_stock_batch_id = #{discountStockBatchId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountStockBatchNo() != null) {
            sql.SET("discount_stock_batch_no = #{discountStockBatchNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountId() != null) {
            sql.SET("discount_id = #{discountId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountNo() != null) {
            sql.SET("discount_no = #{discountNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountName() != null) {
            sql.SET("discount_name = #{discountName,jdbcType=VARCHAR}");
        }
        
        if (record.getObtainType() != null) {
            sql.SET("obtain_type = #{obtainType,jdbcType=INTEGER}");
        }
        
        if (record.getObtainTime() != null) {
            sql.SET("obtain_time = #{obtainTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getReceiveMerUserId() != null) {
            sql.SET("receive_mer_user_id = #{receiveMerUserId,jdbcType=BIGINT}");
        }
        
        if (record.getReceiveMerUserPhone() != null) {
            sql.SET("receive_mer_user_phone = #{receiveMerUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getUseTime() != null) {
            sql.SET("use_time = #{useTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getDiscountPkStockCode() != null) {
            sql.SET("discount_pk_stock_code = #{discountPkStockCode,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountPkId() != null) {
            sql.SET("discount_pk_id = #{discountPkId,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountPkNo() != null) {
            sql.SET("discount_pk_no = #{discountPkNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPkName() != null) {
            sql.SET("discount_pk_name = #{discountPkName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentAppid() != null) {
            sql.SET("agent_appid = #{agentAppid,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsDiscountStockCodeExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}